Empty sort criteria for issue query gives error
Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 3.4.7   

Resolution: Fixed Affected version:  

Description

When saving an Issue query,provide the sort criteria like below, i.e leaving the middle one empty.

 sort.PNG 

Save the query.

With the new query loaded,click on apply.

It gives error.

Bug occured on redmine: 3.4.6

Related issues:

Related to Redmine - Defect #32737: Duplicate sort keys for issue query cause... Closed

Associated revisions

Revision 17638 - 2018-11-26 06:22 - Go MAEDA

Remove blank keys from sort criteria (#30009).

Patch by Marius BALTEANU.

Revision 17639 - 2018-11-26 06:44 - Go MAEDA

Merged r17638 from trunk to 3.4-stable (#30009).

History

#1 - 2018-11-22 11:32 - Go MAEDA

- Category set to Issues

- Status changed from New to Needs feedback

I could not reproduce the problem. Can you see any error regarding this problem in log/production.log ?

#2 - 2018-11-22 11:55 - Kumar Abhinav

It is reproducible on a clean install of Redmine 3.4.6.

After you save the query,make sure the same query is loaded & click apply.

Since the middle criteria for sort is left empty,the to_param method in Redmine::SortCriteria throws "undefined method `+' for nil:NilClass" error.

#3 - 2018-11-22 17:15 - Bernhard Rohloff

I can confirm the defect. It also occurs on the latest trunk.

Switching the query works as expected. As Kumar wrote it only occurs after applying the query a second time.

#4 - 2018-11-23 06:25 - Go MAEDA

- Status changed from Needs feedback to Confirmed

Kumar Abhinav wrote:

After you save the query,make sure the same query is loaded & click apply.
 Yes, I didn't click "Apply" after creating the query. Now I can reproduce the problem.

#5 - 2018-11-25 21:42 - Marius BĂLTEANU

- File 0001-Remove-blank-keys-from-sort-criterias.patch added

- Target version set to Candidate for next minor release

Attached a patch that fixes this problem by removing the blank keys from sort criteria.

Another fix is the below one, but I prefer the first solution.

diff --git a/lib/redmine/sort_criteria.rb b/lib/redmine/sort_criteria.rb

index c89ef03c1..acfcbdb0f 100644

--- a/lib/redmine/sort_criteria.rb

+++ b/lib/redmine/sort_criteria.rb

@@ -32,7 +32,7 @@ module Redmine

     end

     def to_param

-      self.collect {|k,o| k + (o == 'desc' ? ':desc' : '')}.join(',')

+      self.collect {|k,o| k + (o == 'desc' ? ':desc' : '') unless k.nil? }.join(',')

     end

     def to_a

 Also, maybe it is a good idea to fix this issue also in the UI by not allowing to select a third sort criteria without selecting the second.

#6 - 2018-11-25 21:43 - Marius BĂLTEANU

- Subject changed from empty sort criteria for issue query gives error to Empty sort criteria for issue query gives error

#7 - 2018-11-26 06:01 - Go MAEDA

- Target version changed from Candidate for next minor release to 3.4.7

#8 - 2018-11-26 06:24 - Go MAEDA

- Status changed from Confirmed to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

#9 - 2018-11-26 06:46 - Go MAEDA

- Status changed from Resolved to Closed

Committed the patch. Thank you for the patch.

#10 - 2020-01-27 13:00 - Go MAEDA

- Related to Defect #32737: Duplicate sort keys for issue query cause SQL error with SQL Server added

Files
